=== debian/changelog ===
capstone (3.0.4-1) unstable; urgency=medium

  [ Pranith Kumar ]
  * Add rules to build python3 bindings (Closes: #811115, #836275)
  * Adopt the package (Closes: #793691)

  [ Hilko Bengen ]
  * Bump Standards-Version

 -- Pranith Kumar <bobby.prani@gmail.com>  Fri, 23 Dec 2016 15:00:54 -0500

capstone (3.0.4-0.2) unstable; urgency=medium

  * Non-maintainer upload
  * Make python-capstone depend on libcapstone3 (Closes: #797870)

 -- Hilko Bengen <bengen@debian.org>  Sat, 05 Sep 2015 11:39:10 +0200

capstone (3.0.4-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream version
  * Fixed watch file
  * Removed orig-tar script since the non-free header file
    (osxkernel_inttypes.h) is gone.

 -- Hilko Bengen <bengen@debian.org>  Sat, 25 Jul 2015 14:53:53 +0200
