=== debian/control ===
Source: capstone
Priority: optional
Maintainer: Pranith Kumar <bobby.prani@gmail.com>
X-Python-Version: >= 2.7
X-Python3-Version: >= 3.5
Build-Depends: debhelper (>= 9),
               quilt,
               dh-python,
               python,
               python2.7,
               python2.7-dev,
	       python3,
	       python3.5,
	       python3.5-dev,
               cython (>= 0.19)
Standards-Version: 3.9.8
Section: devel
Homepage: http://www.capstone-engine.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/capstone.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/capstone.git;a=summary

Package: libcapstone-dev
Section: libdevel
Architecture: any
Depends: libcapstone3 (= ${binary:Version}), ${misc:Depends}
Description: lightweight multi-architecture disassembly framework - devel files
 Capstone is a lightweight multi-platform, multi-architecture disassembly
 framework.
 .
 These are the development headers and libraries.

Package: libcapstone3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight multi-architecture disassembly framework - library
 Capstone is a lightweight multi-platform, multi-architecture disassembly
 framework.
 .
 Features:
  - Support hardware architectures: ARM, ARM64 (aka ARMv8), Mips, PowerPC &
 Intel.
  - Clean/simple/lightweight/intuitive architecture-neutral API.
  - Provide details on disassembled instructions (called "decomposer" by some
 others).
  - Provide some semantics of the disassembled instruction, such as list of
 implicit registers read & written.
  - Implemented in pure C language, with bindings for Java, OCaml and Python
 ready to use and Ruby, C#, GO & Vala available on git repos.
  - Native support for Windows & *nix (with OS X, Linux, *BSD & Solaris
 confirmed).
  - Thread-safe by design.
  - Special support for embedding into firmware or OS kernel.
  - Distributed under the open source BSD license.

Package: python-capstone
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, libcapstone3
XB-Python-Version: ${python:Versions}
Description: lightweight multi-architecture disassembly framework - Python bindings
 Capstone is a lightweight multi-platform, multi-architecture disassembly
 framework.
 .
 These are the Python 2 bindings.

Package: python3-capstone
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, libcapstone3
XB-Python3-Version: ${python:Versions}
Description: lightweight multi-architecture disassembly framework - Python bindings
 Capstone is a lightweight multi-platform, multi-architecture disassembly
 framework.
 .
 These are the Python 3 bindings.
