=== debian/watch ===
version=3
https://github.com/aquynh/capstone/releases .*/archive/(3\..*)\.tar\.gz
