=== debian/changelog ===
capstone (3.0.5-3) unstable; urgency=medium

  * Fix FTBFS by setting LD_LIBRARY_PATH for tests so that the Python
    tests find libcapstone.so.3

 -- Hilko Bengen <bengen@debian.org>  Fri, 27 Jul 2018 13:35:12 +0200

capstone (3.0.5-2) unstable; urgency=medium

  * Team upload
  * Add fix for loading libcapstone, remove old typos patch (Closes: #904496)

 -- Hilko Bengen <bengen@debian.org>  Wed, 25 Jul 2018 15:23:12 +0200

capstone (3.0.5-1) unstable; urgency=medium

  * Team upload
  * New upstream version 3.0.5
  * Update watch file
  * Update build-dependencies
  * Add capstone-tool package
  * Prevent installation of libcapstone.{so,a} into Python bindings packages
  * Bump Standards-Version
  * Remove X-Python*-Version tags

 -- Hilko Bengen <bengen@debian.org>  Tue, 24 Jul 2018 12:58:52 +0200

capstone (3.0.4-5) unstable; urgency=medium

  * Team upload
  * Add python3-distutils dependency to python3-capstone (Closes: #896265)

 -- Hilko Bengen <bengen@debian.org>  Sat, 21 Apr 2018 15:54:38 +0200

capstone (3.0.4-4) unstable; urgency=medium

  * Team upload
  [ Raphaël Hertzog ]
  * Set Maintainer field to Debian Security Tools
    <team+pkg-security@tracker.debian.org>
  * Update Vcs-Git and Vcs-Browser for the move to salsa.debian.org

  [ Hilko Bengen ]
  * Bump Standards-Version, Debhelper compat level
  * Add Multi-Arch support

 -- Hilko Bengen <bengen@debian.org>  Sat, 31 Mar 2018 23:04:14 +0200

capstone (3.0.4-3) unstable; urgency=medium

  * Fix chroot build and add proper python3 dependency
  * Further modification after sponsoring request:
    - Add overrides for clean, configure steps, set LD_LIBRARY_PATH for
      tests

 -- Hilko Bengen <bengen@debian.org>  Sun, 30 Jul 2017 14:26:50 +0200

capstone (3.0.4-2) unstable; urgency=medium

  [ Adrian Bunk ]
  * python3-capstone lacks python dependency (Closes: #867204)

 -- Pranith Kumar <bobby.prani@gmail.com>  Tue, 04 Jul 2017 16:52:06 -0400
