=== debian/control ===
--- 
+++ 
@@ -1,27 +1,22 @@
 Source: capstone
 Priority: optional
-Maintainer: Pranith Kumar <bobby.prani@gmail.com>
-X-Python-Version: >= 2.7
-X-Python3-Version: >= 3.5
-Build-Depends: debhelper (>= 9),
-               quilt,
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Uploaders: Pranith Kumar <bobby.prani@gmail.com>
+Build-Depends: debhelper (>= 10),
                dh-python,
-               python,
-               python2.7,
-               python2.7-dev,
-	       python3,
-	       python3.5,
-	       python3.5-dev,
-               cython (>= 0.19)
-Standards-Version: 3.9.8
+               python-all-dev, python3-all-dev,
+               python-setuptools, python3-setuptools,
+               cython (>= 0.19), cython3,
+Standards-Version: 4.1.5
 Section: devel
 Homepage: http://www.capstone-engine.org/
-Vcs-Git: git://anonscm.debian.org/collab-maint/capstone.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/capstone.git;a=summary
+Vcs-Git: https://salsa.debian.org/pkg-security-team/capstone.git
+Vcs-Browser: https://salsa.debian.org/pkg-security-team/capstone
 
 Package: libcapstone-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: libcapstone3 (= ${binary:Version}), ${misc:Depends}
 Description: lightweight multi-architecture disassembly framework - devel files
  Capstone is a lightweight multi-platform, multi-architecture disassembly
@@ -32,6 +27,7 @@
 Package: libcapstone3
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: lightweight multi-architecture disassembly framework - library
  Capstone is a lightweight multi-platform, multi-architecture disassembly
@@ -53,6 +49,18 @@
   - Special support for embedding into firmware or OS kernel.
   - Distributed under the open source BSD license.
 
+Package: capstone-tool
+Section: libs
+Architecture: any
+Multi-Arch: allowed
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: lightweight multi-architecture disassembly framework - command line tool
+ Capstone is a lightweight multi-platform, multi-architecture disassembly
+ framework.
+ .
+ This package contains cstool, a command-line tool to disassemble
+ hexadecimal strings.
+
 Package: python-capstone
 Section: python
 Architecture: any
@@ -67,7 +75,8 @@
 Package: python3-capstone
 Section: python
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, libcapstone3
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, libcapstone3,
+ python3-distutils
 XB-Python3-Version: ${python:Versions}
 Description: lightweight multi-architecture disassembly framework - Python bindings
  Capstone is a lightweight multi-platform, multi-architecture disassembly
